/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the JsonSchemaProperty type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JsonSchemaProperty{}

// JsonSchemaProperty struct for JsonSchemaProperty
type JsonSchemaProperty struct {
	Schema                    NullableString                 `json:"$schema,omitempty"`
	Id                        NullableString                 `json:"id,omitempty"`
	Title                     NullableString                 `json:"title,omitempty"`
	Type                      interface{}                    `json:"type,omitempty"`
	Discriminator             interface{}                    `json:"discriminator,omitempty"`
	XReadOnly                 *bool                          `json:"x-readOnly,omitempty"`
	XWriteOnly                *bool                          `json:"x-writeOnly,omitempty"`
	Description               NullableString                 `json:"description,omitempty"`
	Format                    NullableString                 `json:"format,omitempty"`
	Default                   interface{}                    `json:"default,omitempty"`
	MultipleOf                NullableFloat64                `json:"multipleOf,omitempty"`
	Maximum                   NullableFloat64                `json:"maximum,omitempty"`
	Minimum                   NullableFloat64                `json:"minimum,omitempty"`
	MaxLength                 NullableInt32                  `json:"maxLength,omitempty"`
	MinLength                 NullableInt32                  `json:"minLength,omitempty"`
	Pattern                   NullableString                 `json:"pattern,omitempty"`
	MaxItems                  *int32                         `json:"maxItems,omitempty"`
	MinItems                  *int32                         `json:"minItems,omitempty"`
	UniqueItems               *bool                          `json:"uniqueItems,omitempty"`
	MaxProperties             *int32                         `json:"maxProperties,omitempty"`
	MinProperties             *int32                         `json:"minProperties,omitempty"`
	XDeprecated               *bool                          `json:"x-deprecated,omitempty"`
	XDeprecatedMessage        NullableString                 `json:"x-deprecatedMessage,omitempty"`
	XAbstract                 *bool                          `json:"x-abstract,omitempty"`
	XNullable                 NullableBool                   `json:"x-nullable,omitempty"`
	XExample                  interface{}                    `json:"x-example,omitempty"`
	XEnumFlags                *bool                          `json:"x-enumFlags,omitempty"`
	XDictionaryKey            *JsonSchema                    `json:"x-dictionaryKey,omitempty"`
	Xml                       *JsonXmlObject                 `json:"xml,omitempty"`
	Not                       *JsonSchema                    `json:"not,omitempty"`
	ExclusiveMaximum          interface{}                    `json:"exclusiveMaximum,omitempty"`
	ExclusiveMinimum          interface{}                    `json:"exclusiveMinimum,omitempty"`
	AdditionalItems           interface{}                    `json:"additionalItems,omitempty"`
	AdditionalPropertiesField interface{}                    `json:"additionalProperties,omitempty"`
	Items                     interface{}                    `json:"items,omitempty"`
	Required                  []string                       `json:"required,omitempty"`
	Properties                *map[string]JsonSchemaProperty `json:"properties,omitempty"`
	PatternProperties         *map[string]JsonSchemaProperty `json:"patternProperties,omitempty"`
	Definitions               *map[string]JsonSchema         `json:"definitions,omitempty"`
	XEnumNames                []string                       `json:"x-enumNames,omitempty"`
	Enum                      []interface{}                  `json:"enum,omitempty"`
	AllOf                     []JsonSchema                   `json:"allOf,omitempty"`
	AnyOf                     []JsonSchema                   `json:"anyOf,omitempty"`
	OneOf                     []JsonSchema                   `json:"oneOf,omitempty"`
	Ref                       *string                        `json:"$ref,omitempty"`
	AdditionalProperties      map[string]interface{}
}

type _JsonSchemaProperty JsonSchemaProperty

// NewJsonSchemaProperty instantiates a new JsonSchemaProperty object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJsonSchemaProperty() *JsonSchemaProperty {
	this := JsonSchemaProperty{}
	var xReadOnly bool = false
	this.XReadOnly = &xReadOnly
	var xWriteOnly bool = false
	this.XWriteOnly = &xWriteOnly
	return &this
}

// NewJsonSchemaPropertyWithDefaults instantiates a new JsonSchemaProperty object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJsonSchemaPropertyWithDefaults() *JsonSchemaProperty {
	this := JsonSchemaProperty{}
	var xReadOnly bool = false
	this.XReadOnly = &xReadOnly
	var xWriteOnly bool = false
	this.XWriteOnly = &xWriteOnly
	return &this
}

// GetSchema returns the Schema field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetSchema() string {
	if o == nil || IsNil(o.Schema.Get()) {
		var ret string
		return ret
	}
	return *o.Schema.Get()
}

// GetSchemaOk returns a tuple with the Schema field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetSchemaOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Schema.Get(), o.Schema.IsSet()
}

// HasSchema returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasSchema() bool {
	if o != nil && o.Schema.IsSet() {
		return true
	}

	return false
}

// SetSchema gets a reference to the given NullableString and assigns it to the Schema field.
func (o *JsonSchemaProperty) SetSchema(v string) {
	o.Schema.Set(&v)
}

// SetSchemaNil sets the value for Schema to be an explicit nil
func (o *JsonSchemaProperty) SetSchemaNil() {
	o.Schema.Set(nil)
}

// UnsetSchema ensures that no value is present for Schema, not even an explicit nil
func (o *JsonSchemaProperty) UnsetSchema() {
	o.Schema.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *JsonSchemaProperty) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *JsonSchemaProperty) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *JsonSchemaProperty) UnsetId() {
	o.Id.Unset()
}

// GetTitle returns the Title field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetTitle() string {
	if o == nil || IsNil(o.Title.Get()) {
		var ret string
		return ret
	}
	return *o.Title.Get()
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetTitleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Title.Get(), o.Title.IsSet()
}

// HasTitle returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasTitle() bool {
	if o != nil && o.Title.IsSet() {
		return true
	}

	return false
}

// SetTitle gets a reference to the given NullableString and assigns it to the Title field.
func (o *JsonSchemaProperty) SetTitle(v string) {
	o.Title.Set(&v)
}

// SetTitleNil sets the value for Title to be an explicit nil
func (o *JsonSchemaProperty) SetTitleNil() {
	o.Title.Set(nil)
}

// UnsetTitle ensures that no value is present for Title, not even an explicit nil
func (o *JsonSchemaProperty) UnsetTitle() {
	o.Title.Unset()
}

// GetType returns the Type field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetType() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetTypeOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return &o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given interface{} and assigns it to the Type field.
func (o *JsonSchemaProperty) SetType(v interface{}) {
	o.Type = v
}

// GetDiscriminator returns the Discriminator field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetDiscriminator() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Discriminator
}

// GetDiscriminatorOk returns a tuple with the Discriminator field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetDiscriminatorOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Discriminator) {
		return nil, false
	}
	return &o.Discriminator, true
}

// HasDiscriminator returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasDiscriminator() bool {
	if o != nil && !IsNil(o.Discriminator) {
		return true
	}

	return false
}

// SetDiscriminator gets a reference to the given interface{} and assigns it to the Discriminator field.
func (o *JsonSchemaProperty) SetDiscriminator(v interface{}) {
	o.Discriminator = v
}

// GetXReadOnly returns the XReadOnly field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetXReadOnly() bool {
	if o == nil || IsNil(o.XReadOnly) {
		var ret bool
		return ret
	}
	return *o.XReadOnly
}

// GetXReadOnlyOk returns a tuple with the XReadOnly field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetXReadOnlyOk() (*bool, bool) {
	if o == nil || IsNil(o.XReadOnly) {
		return nil, false
	}
	return o.XReadOnly, true
}

// HasXReadOnly returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXReadOnly() bool {
	if o != nil && !IsNil(o.XReadOnly) {
		return true
	}

	return false
}

// SetXReadOnly gets a reference to the given bool and assigns it to the XReadOnly field.
func (o *JsonSchemaProperty) SetXReadOnly(v bool) {
	o.XReadOnly = &v
}

// GetXWriteOnly returns the XWriteOnly field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetXWriteOnly() bool {
	if o == nil || IsNil(o.XWriteOnly) {
		var ret bool
		return ret
	}
	return *o.XWriteOnly
}

// GetXWriteOnlyOk returns a tuple with the XWriteOnly field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetXWriteOnlyOk() (*bool, bool) {
	if o == nil || IsNil(o.XWriteOnly) {
		return nil, false
	}
	return o.XWriteOnly, true
}

// HasXWriteOnly returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXWriteOnly() bool {
	if o != nil && !IsNil(o.XWriteOnly) {
		return true
	}

	return false
}

// SetXWriteOnly gets a reference to the given bool and assigns it to the XWriteOnly field.
func (o *JsonSchemaProperty) SetXWriteOnly(v bool) {
	o.XWriteOnly = &v
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *JsonSchemaProperty) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *JsonSchemaProperty) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *JsonSchemaProperty) UnsetDescription() {
	o.Description.Unset()
}

// GetFormat returns the Format field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetFormat() string {
	if o == nil || IsNil(o.Format.Get()) {
		var ret string
		return ret
	}
	return *o.Format.Get()
}

// GetFormatOk returns a tuple with the Format field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetFormatOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Format.Get(), o.Format.IsSet()
}

// HasFormat returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasFormat() bool {
	if o != nil && o.Format.IsSet() {
		return true
	}

	return false
}

// SetFormat gets a reference to the given NullableString and assigns it to the Format field.
func (o *JsonSchemaProperty) SetFormat(v string) {
	o.Format.Set(&v)
}

// SetFormatNil sets the value for Format to be an explicit nil
func (o *JsonSchemaProperty) SetFormatNil() {
	o.Format.Set(nil)
}

// UnsetFormat ensures that no value is present for Format, not even an explicit nil
func (o *JsonSchemaProperty) UnsetFormat() {
	o.Format.Unset()
}

// GetDefault returns the Default field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetDefault() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Default
}

// GetDefaultOk returns a tuple with the Default field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetDefaultOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Default) {
		return nil, false
	}
	return &o.Default, true
}

// HasDefault returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasDefault() bool {
	if o != nil && !IsNil(o.Default) {
		return true
	}

	return false
}

// SetDefault gets a reference to the given interface{} and assigns it to the Default field.
func (o *JsonSchemaProperty) SetDefault(v interface{}) {
	o.Default = v
}

// GetMultipleOf returns the MultipleOf field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetMultipleOf() float64 {
	if o == nil || IsNil(o.MultipleOf.Get()) {
		var ret float64
		return ret
	}
	return *o.MultipleOf.Get()
}

// GetMultipleOfOk returns a tuple with the MultipleOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetMultipleOfOk() (*float64, bool) {
	if o == nil {
		return nil, false
	}
	return o.MultipleOf.Get(), o.MultipleOf.IsSet()
}

// HasMultipleOf returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMultipleOf() bool {
	if o != nil && o.MultipleOf.IsSet() {
		return true
	}

	return false
}

// SetMultipleOf gets a reference to the given NullableFloat64 and assigns it to the MultipleOf field.
func (o *JsonSchemaProperty) SetMultipleOf(v float64) {
	o.MultipleOf.Set(&v)
}

// SetMultipleOfNil sets the value for MultipleOf to be an explicit nil
func (o *JsonSchemaProperty) SetMultipleOfNil() {
	o.MultipleOf.Set(nil)
}

// UnsetMultipleOf ensures that no value is present for MultipleOf, not even an explicit nil
func (o *JsonSchemaProperty) UnsetMultipleOf() {
	o.MultipleOf.Unset()
}

// GetMaximum returns the Maximum field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetMaximum() float64 {
	if o == nil || IsNil(o.Maximum.Get()) {
		var ret float64
		return ret
	}
	return *o.Maximum.Get()
}

// GetMaximumOk returns a tuple with the Maximum field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetMaximumOk() (*float64, bool) {
	if o == nil {
		return nil, false
	}
	return o.Maximum.Get(), o.Maximum.IsSet()
}

// HasMaximum returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMaximum() bool {
	if o != nil && o.Maximum.IsSet() {
		return true
	}

	return false
}

// SetMaximum gets a reference to the given NullableFloat64 and assigns it to the Maximum field.
func (o *JsonSchemaProperty) SetMaximum(v float64) {
	o.Maximum.Set(&v)
}

// SetMaximumNil sets the value for Maximum to be an explicit nil
func (o *JsonSchemaProperty) SetMaximumNil() {
	o.Maximum.Set(nil)
}

// UnsetMaximum ensures that no value is present for Maximum, not even an explicit nil
func (o *JsonSchemaProperty) UnsetMaximum() {
	o.Maximum.Unset()
}

// GetMinimum returns the Minimum field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetMinimum() float64 {
	if o == nil || IsNil(o.Minimum.Get()) {
		var ret float64
		return ret
	}
	return *o.Minimum.Get()
}

// GetMinimumOk returns a tuple with the Minimum field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetMinimumOk() (*float64, bool) {
	if o == nil {
		return nil, false
	}
	return o.Minimum.Get(), o.Minimum.IsSet()
}

// HasMinimum returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMinimum() bool {
	if o != nil && o.Minimum.IsSet() {
		return true
	}

	return false
}

// SetMinimum gets a reference to the given NullableFloat64 and assigns it to the Minimum field.
func (o *JsonSchemaProperty) SetMinimum(v float64) {
	o.Minimum.Set(&v)
}

// SetMinimumNil sets the value for Minimum to be an explicit nil
func (o *JsonSchemaProperty) SetMinimumNil() {
	o.Minimum.Set(nil)
}

// UnsetMinimum ensures that no value is present for Minimum, not even an explicit nil
func (o *JsonSchemaProperty) UnsetMinimum() {
	o.Minimum.Unset()
}

// GetMaxLength returns the MaxLength field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetMaxLength() int32 {
	if o == nil || IsNil(o.MaxLength.Get()) {
		var ret int32
		return ret
	}
	return *o.MaxLength.Get()
}

// GetMaxLengthOk returns a tuple with the MaxLength field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetMaxLengthOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.MaxLength.Get(), o.MaxLength.IsSet()
}

// HasMaxLength returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMaxLength() bool {
	if o != nil && o.MaxLength.IsSet() {
		return true
	}

	return false
}

// SetMaxLength gets a reference to the given NullableInt32 and assigns it to the MaxLength field.
func (o *JsonSchemaProperty) SetMaxLength(v int32) {
	o.MaxLength.Set(&v)
}

// SetMaxLengthNil sets the value for MaxLength to be an explicit nil
func (o *JsonSchemaProperty) SetMaxLengthNil() {
	o.MaxLength.Set(nil)
}

// UnsetMaxLength ensures that no value is present for MaxLength, not even an explicit nil
func (o *JsonSchemaProperty) UnsetMaxLength() {
	o.MaxLength.Unset()
}

// GetMinLength returns the MinLength field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetMinLength() int32 {
	if o == nil || IsNil(o.MinLength.Get()) {
		var ret int32
		return ret
	}
	return *o.MinLength.Get()
}

// GetMinLengthOk returns a tuple with the MinLength field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetMinLengthOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.MinLength.Get(), o.MinLength.IsSet()
}

// HasMinLength returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMinLength() bool {
	if o != nil && o.MinLength.IsSet() {
		return true
	}

	return false
}

// SetMinLength gets a reference to the given NullableInt32 and assigns it to the MinLength field.
func (o *JsonSchemaProperty) SetMinLength(v int32) {
	o.MinLength.Set(&v)
}

// SetMinLengthNil sets the value for MinLength to be an explicit nil
func (o *JsonSchemaProperty) SetMinLengthNil() {
	o.MinLength.Set(nil)
}

// UnsetMinLength ensures that no value is present for MinLength, not even an explicit nil
func (o *JsonSchemaProperty) UnsetMinLength() {
	o.MinLength.Unset()
}

// GetPattern returns the Pattern field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetPattern() string {
	if o == nil || IsNil(o.Pattern.Get()) {
		var ret string
		return ret
	}
	return *o.Pattern.Get()
}

// GetPatternOk returns a tuple with the Pattern field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetPatternOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Pattern.Get(), o.Pattern.IsSet()
}

// HasPattern returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasPattern() bool {
	if o != nil && o.Pattern.IsSet() {
		return true
	}

	return false
}

// SetPattern gets a reference to the given NullableString and assigns it to the Pattern field.
func (o *JsonSchemaProperty) SetPattern(v string) {
	o.Pattern.Set(&v)
}

// SetPatternNil sets the value for Pattern to be an explicit nil
func (o *JsonSchemaProperty) SetPatternNil() {
	o.Pattern.Set(nil)
}

// UnsetPattern ensures that no value is present for Pattern, not even an explicit nil
func (o *JsonSchemaProperty) UnsetPattern() {
	o.Pattern.Unset()
}

// GetMaxItems returns the MaxItems field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetMaxItems() int32 {
	if o == nil || IsNil(o.MaxItems) {
		var ret int32
		return ret
	}
	return *o.MaxItems
}

// GetMaxItemsOk returns a tuple with the MaxItems field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetMaxItemsOk() (*int32, bool) {
	if o == nil || IsNil(o.MaxItems) {
		return nil, false
	}
	return o.MaxItems, true
}

// HasMaxItems returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMaxItems() bool {
	if o != nil && !IsNil(o.MaxItems) {
		return true
	}

	return false
}

// SetMaxItems gets a reference to the given int32 and assigns it to the MaxItems field.
func (o *JsonSchemaProperty) SetMaxItems(v int32) {
	o.MaxItems = &v
}

// GetMinItems returns the MinItems field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetMinItems() int32 {
	if o == nil || IsNil(o.MinItems) {
		var ret int32
		return ret
	}
	return *o.MinItems
}

// GetMinItemsOk returns a tuple with the MinItems field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetMinItemsOk() (*int32, bool) {
	if o == nil || IsNil(o.MinItems) {
		return nil, false
	}
	return o.MinItems, true
}

// HasMinItems returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMinItems() bool {
	if o != nil && !IsNil(o.MinItems) {
		return true
	}

	return false
}

// SetMinItems gets a reference to the given int32 and assigns it to the MinItems field.
func (o *JsonSchemaProperty) SetMinItems(v int32) {
	o.MinItems = &v
}

// GetUniqueItems returns the UniqueItems field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetUniqueItems() bool {
	if o == nil || IsNil(o.UniqueItems) {
		var ret bool
		return ret
	}
	return *o.UniqueItems
}

// GetUniqueItemsOk returns a tuple with the UniqueItems field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetUniqueItemsOk() (*bool, bool) {
	if o == nil || IsNil(o.UniqueItems) {
		return nil, false
	}
	return o.UniqueItems, true
}

// HasUniqueItems returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasUniqueItems() bool {
	if o != nil && !IsNil(o.UniqueItems) {
		return true
	}

	return false
}

// SetUniqueItems gets a reference to the given bool and assigns it to the UniqueItems field.
func (o *JsonSchemaProperty) SetUniqueItems(v bool) {
	o.UniqueItems = &v
}

// GetMaxProperties returns the MaxProperties field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetMaxProperties() int32 {
	if o == nil || IsNil(o.MaxProperties) {
		var ret int32
		return ret
	}
	return *o.MaxProperties
}

// GetMaxPropertiesOk returns a tuple with the MaxProperties field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetMaxPropertiesOk() (*int32, bool) {
	if o == nil || IsNil(o.MaxProperties) {
		return nil, false
	}
	return o.MaxProperties, true
}

// HasMaxProperties returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMaxProperties() bool {
	if o != nil && !IsNil(o.MaxProperties) {
		return true
	}

	return false
}

// SetMaxProperties gets a reference to the given int32 and assigns it to the MaxProperties field.
func (o *JsonSchemaProperty) SetMaxProperties(v int32) {
	o.MaxProperties = &v
}

// GetMinProperties returns the MinProperties field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetMinProperties() int32 {
	if o == nil || IsNil(o.MinProperties) {
		var ret int32
		return ret
	}
	return *o.MinProperties
}

// GetMinPropertiesOk returns a tuple with the MinProperties field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetMinPropertiesOk() (*int32, bool) {
	if o == nil || IsNil(o.MinProperties) {
		return nil, false
	}
	return o.MinProperties, true
}

// HasMinProperties returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasMinProperties() bool {
	if o != nil && !IsNil(o.MinProperties) {
		return true
	}

	return false
}

// SetMinProperties gets a reference to the given int32 and assigns it to the MinProperties field.
func (o *JsonSchemaProperty) SetMinProperties(v int32) {
	o.MinProperties = &v
}

// GetXDeprecated returns the XDeprecated field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetXDeprecated() bool {
	if o == nil || IsNil(o.XDeprecated) {
		var ret bool
		return ret
	}
	return *o.XDeprecated
}

// GetXDeprecatedOk returns a tuple with the XDeprecated field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetXDeprecatedOk() (*bool, bool) {
	if o == nil || IsNil(o.XDeprecated) {
		return nil, false
	}
	return o.XDeprecated, true
}

// HasXDeprecated returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXDeprecated() bool {
	if o != nil && !IsNil(o.XDeprecated) {
		return true
	}

	return false
}

// SetXDeprecated gets a reference to the given bool and assigns it to the XDeprecated field.
func (o *JsonSchemaProperty) SetXDeprecated(v bool) {
	o.XDeprecated = &v
}

// GetXDeprecatedMessage returns the XDeprecatedMessage field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetXDeprecatedMessage() string {
	if o == nil || IsNil(o.XDeprecatedMessage.Get()) {
		var ret string
		return ret
	}
	return *o.XDeprecatedMessage.Get()
}

// GetXDeprecatedMessageOk returns a tuple with the XDeprecatedMessage field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetXDeprecatedMessageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.XDeprecatedMessage.Get(), o.XDeprecatedMessage.IsSet()
}

// HasXDeprecatedMessage returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXDeprecatedMessage() bool {
	if o != nil && o.XDeprecatedMessage.IsSet() {
		return true
	}

	return false
}

// SetXDeprecatedMessage gets a reference to the given NullableString and assigns it to the XDeprecatedMessage field.
func (o *JsonSchemaProperty) SetXDeprecatedMessage(v string) {
	o.XDeprecatedMessage.Set(&v)
}

// SetXDeprecatedMessageNil sets the value for XDeprecatedMessage to be an explicit nil
func (o *JsonSchemaProperty) SetXDeprecatedMessageNil() {
	o.XDeprecatedMessage.Set(nil)
}

// UnsetXDeprecatedMessage ensures that no value is present for XDeprecatedMessage, not even an explicit nil
func (o *JsonSchemaProperty) UnsetXDeprecatedMessage() {
	o.XDeprecatedMessage.Unset()
}

// GetXAbstract returns the XAbstract field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetXAbstract() bool {
	if o == nil || IsNil(o.XAbstract) {
		var ret bool
		return ret
	}
	return *o.XAbstract
}

// GetXAbstractOk returns a tuple with the XAbstract field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetXAbstractOk() (*bool, bool) {
	if o == nil || IsNil(o.XAbstract) {
		return nil, false
	}
	return o.XAbstract, true
}

// HasXAbstract returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXAbstract() bool {
	if o != nil && !IsNil(o.XAbstract) {
		return true
	}

	return false
}

// SetXAbstract gets a reference to the given bool and assigns it to the XAbstract field.
func (o *JsonSchemaProperty) SetXAbstract(v bool) {
	o.XAbstract = &v
}

// GetXNullable returns the XNullable field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetXNullable() bool {
	if o == nil || IsNil(o.XNullable.Get()) {
		var ret bool
		return ret
	}
	return *o.XNullable.Get()
}

// GetXNullableOk returns a tuple with the XNullable field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetXNullableOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return o.XNullable.Get(), o.XNullable.IsSet()
}

// HasXNullable returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXNullable() bool {
	if o != nil && o.XNullable.IsSet() {
		return true
	}

	return false
}

// SetXNullable gets a reference to the given NullableBool and assigns it to the XNullable field.
func (o *JsonSchemaProperty) SetXNullable(v bool) {
	o.XNullable.Set(&v)
}

// SetXNullableNil sets the value for XNullable to be an explicit nil
func (o *JsonSchemaProperty) SetXNullableNil() {
	o.XNullable.Set(nil)
}

// UnsetXNullable ensures that no value is present for XNullable, not even an explicit nil
func (o *JsonSchemaProperty) UnsetXNullable() {
	o.XNullable.Unset()
}

// GetXExample returns the XExample field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetXExample() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.XExample
}

// GetXExampleOk returns a tuple with the XExample field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetXExampleOk() (*interface{}, bool) {
	if o == nil || IsNil(o.XExample) {
		return nil, false
	}
	return &o.XExample, true
}

// HasXExample returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXExample() bool {
	if o != nil && !IsNil(o.XExample) {
		return true
	}

	return false
}

// SetXExample gets a reference to the given interface{} and assigns it to the XExample field.
func (o *JsonSchemaProperty) SetXExample(v interface{}) {
	o.XExample = v
}

// GetXEnumFlags returns the XEnumFlags field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetXEnumFlags() bool {
	if o == nil || IsNil(o.XEnumFlags) {
		var ret bool
		return ret
	}
	return *o.XEnumFlags
}

// GetXEnumFlagsOk returns a tuple with the XEnumFlags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetXEnumFlagsOk() (*bool, bool) {
	if o == nil || IsNil(o.XEnumFlags) {
		return nil, false
	}
	return o.XEnumFlags, true
}

// HasXEnumFlags returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXEnumFlags() bool {
	if o != nil && !IsNil(o.XEnumFlags) {
		return true
	}

	return false
}

// SetXEnumFlags gets a reference to the given bool and assigns it to the XEnumFlags field.
func (o *JsonSchemaProperty) SetXEnumFlags(v bool) {
	o.XEnumFlags = &v
}

// GetXDictionaryKey returns the XDictionaryKey field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetXDictionaryKey() JsonSchema {
	if o == nil || IsNil(o.XDictionaryKey) {
		var ret JsonSchema
		return ret
	}
	return *o.XDictionaryKey
}

// GetXDictionaryKeyOk returns a tuple with the XDictionaryKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetXDictionaryKeyOk() (*JsonSchema, bool) {
	if o == nil || IsNil(o.XDictionaryKey) {
		return nil, false
	}
	return o.XDictionaryKey, true
}

// HasXDictionaryKey returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXDictionaryKey() bool {
	if o != nil && !IsNil(o.XDictionaryKey) {
		return true
	}

	return false
}

// SetXDictionaryKey gets a reference to the given JsonSchema and assigns it to the XDictionaryKey field.
func (o *JsonSchemaProperty) SetXDictionaryKey(v JsonSchema) {
	o.XDictionaryKey = &v
}

// GetXml returns the Xml field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetXml() JsonXmlObject {
	if o == nil || IsNil(o.Xml) {
		var ret JsonXmlObject
		return ret
	}
	return *o.Xml
}

// GetXmlOk returns a tuple with the Xml field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetXmlOk() (*JsonXmlObject, bool) {
	if o == nil || IsNil(o.Xml) {
		return nil, false
	}
	return o.Xml, true
}

// HasXml returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXml() bool {
	if o != nil && !IsNil(o.Xml) {
		return true
	}

	return false
}

// SetXml gets a reference to the given JsonXmlObject and assigns it to the Xml field.
func (o *JsonSchemaProperty) SetXml(v JsonXmlObject) {
	o.Xml = &v
}

// GetNot returns the Not field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetNot() JsonSchema {
	if o == nil || IsNil(o.Not) {
		var ret JsonSchema
		return ret
	}
	return *o.Not
}

// GetNotOk returns a tuple with the Not field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetNotOk() (*JsonSchema, bool) {
	if o == nil || IsNil(o.Not) {
		return nil, false
	}
	return o.Not, true
}

// HasNot returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasNot() bool {
	if o != nil && !IsNil(o.Not) {
		return true
	}

	return false
}

// SetNot gets a reference to the given JsonSchema and assigns it to the Not field.
func (o *JsonSchemaProperty) SetNot(v JsonSchema) {
	o.Not = &v
}

// GetExclusiveMaximum returns the ExclusiveMaximum field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetExclusiveMaximum() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ExclusiveMaximum
}

// GetExclusiveMaximumOk returns a tuple with the ExclusiveMaximum field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetExclusiveMaximumOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ExclusiveMaximum) {
		return nil, false
	}
	return &o.ExclusiveMaximum, true
}

// HasExclusiveMaximum returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasExclusiveMaximum() bool {
	if o != nil && !IsNil(o.ExclusiveMaximum) {
		return true
	}

	return false
}

// SetExclusiveMaximum gets a reference to the given interface{} and assigns it to the ExclusiveMaximum field.
func (o *JsonSchemaProperty) SetExclusiveMaximum(v interface{}) {
	o.ExclusiveMaximum = v
}

// GetExclusiveMinimum returns the ExclusiveMinimum field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetExclusiveMinimum() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ExclusiveMinimum
}

// GetExclusiveMinimumOk returns a tuple with the ExclusiveMinimum field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetExclusiveMinimumOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ExclusiveMinimum) {
		return nil, false
	}
	return &o.ExclusiveMinimum, true
}

// HasExclusiveMinimum returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasExclusiveMinimum() bool {
	if o != nil && !IsNil(o.ExclusiveMinimum) {
		return true
	}

	return false
}

// SetExclusiveMinimum gets a reference to the given interface{} and assigns it to the ExclusiveMinimum field.
func (o *JsonSchemaProperty) SetExclusiveMinimum(v interface{}) {
	o.ExclusiveMinimum = v
}

// GetAdditionalItems returns the AdditionalItems field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetAdditionalItems() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.AdditionalItems
}

// GetAdditionalItemsOk returns a tuple with the AdditionalItems field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetAdditionalItemsOk() (*interface{}, bool) {
	if o == nil || IsNil(o.AdditionalItems) {
		return nil, false
	}
	return &o.AdditionalItems, true
}

// HasAdditionalItems returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasAdditionalItems() bool {
	if o != nil && !IsNil(o.AdditionalItems) {
		return true
	}

	return false
}

// SetAdditionalItems gets a reference to the given interface{} and assigns it to the AdditionalItems field.
func (o *JsonSchemaProperty) SetAdditionalItems(v interface{}) {
	o.AdditionalItems = v
}

// GetAdditionalPropertiesField returns the AdditionalPropertiesField field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetAdditionalPropertiesField() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.AdditionalPropertiesField
}

// GetAdditionalPropertiesFieldOk returns a tuple with the AdditionalPropertiesField field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetAdditionalPropertiesFieldOk() (*interface{}, bool) {
	if o == nil || IsNil(o.AdditionalPropertiesField) {
		return nil, false
	}
	return &o.AdditionalPropertiesField, true
}

// HasAdditionalPropertiesField returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasAdditionalPropertiesField() bool {
	if o != nil && !IsNil(o.AdditionalPropertiesField) {
		return true
	}

	return false
}

// SetAdditionalPropertiesField gets a reference to the given interface{} and assigns it to the AdditionalPropertiesField field.
func (o *JsonSchemaProperty) SetAdditionalPropertiesField(v interface{}) {
	o.AdditionalPropertiesField = v
}

// GetItems returns the Items field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchemaProperty) GetItems() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchemaProperty) GetItemsOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Items) {
		return nil, false
	}
	return &o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasItems() bool {
	if o != nil && !IsNil(o.Items) {
		return true
	}

	return false
}

// SetItems gets a reference to the given interface{} and assigns it to the Items field.
func (o *JsonSchemaProperty) SetItems(v interface{}) {
	o.Items = v
}

// GetRequired returns the Required field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetRequired() []string {
	if o == nil || IsNil(o.Required) {
		var ret []string
		return ret
	}
	return o.Required
}

// GetRequiredOk returns a tuple with the Required field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetRequiredOk() ([]string, bool) {
	if o == nil || IsNil(o.Required) {
		return nil, false
	}
	return o.Required, true
}

// HasRequired returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasRequired() bool {
	if o != nil && !IsNil(o.Required) {
		return true
	}

	return false
}

// SetRequired gets a reference to the given []string and assigns it to the Required field.
func (o *JsonSchemaProperty) SetRequired(v []string) {
	o.Required = v
}

// GetProperties returns the Properties field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetProperties() map[string]JsonSchemaProperty {
	if o == nil || IsNil(o.Properties) {
		var ret map[string]JsonSchemaProperty
		return ret
	}
	return *o.Properties
}

// GetPropertiesOk returns a tuple with the Properties field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetPropertiesOk() (*map[string]JsonSchemaProperty, bool) {
	if o == nil || IsNil(o.Properties) {
		return nil, false
	}
	return o.Properties, true
}

// HasProperties returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasProperties() bool {
	if o != nil && !IsNil(o.Properties) {
		return true
	}

	return false
}

// SetProperties gets a reference to the given map[string]JsonSchemaProperty and assigns it to the Properties field.
func (o *JsonSchemaProperty) SetProperties(v map[string]JsonSchemaProperty) {
	o.Properties = &v
}

// GetPatternProperties returns the PatternProperties field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetPatternProperties() map[string]JsonSchemaProperty {
	if o == nil || IsNil(o.PatternProperties) {
		var ret map[string]JsonSchemaProperty
		return ret
	}
	return *o.PatternProperties
}

// GetPatternPropertiesOk returns a tuple with the PatternProperties field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetPatternPropertiesOk() (*map[string]JsonSchemaProperty, bool) {
	if o == nil || IsNil(o.PatternProperties) {
		return nil, false
	}
	return o.PatternProperties, true
}

// HasPatternProperties returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasPatternProperties() bool {
	if o != nil && !IsNil(o.PatternProperties) {
		return true
	}

	return false
}

// SetPatternProperties gets a reference to the given map[string]JsonSchemaProperty and assigns it to the PatternProperties field.
func (o *JsonSchemaProperty) SetPatternProperties(v map[string]JsonSchemaProperty) {
	o.PatternProperties = &v
}

// GetDefinitions returns the Definitions field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetDefinitions() map[string]JsonSchema {
	if o == nil || IsNil(o.Definitions) {
		var ret map[string]JsonSchema
		return ret
	}
	return *o.Definitions
}

// GetDefinitionsOk returns a tuple with the Definitions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetDefinitionsOk() (*map[string]JsonSchema, bool) {
	if o == nil || IsNil(o.Definitions) {
		return nil, false
	}
	return o.Definitions, true
}

// HasDefinitions returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasDefinitions() bool {
	if o != nil && !IsNil(o.Definitions) {
		return true
	}

	return false
}

// SetDefinitions gets a reference to the given map[string]JsonSchema and assigns it to the Definitions field.
func (o *JsonSchemaProperty) SetDefinitions(v map[string]JsonSchema) {
	o.Definitions = &v
}

// GetXEnumNames returns the XEnumNames field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetXEnumNames() []string {
	if o == nil || IsNil(o.XEnumNames) {
		var ret []string
		return ret
	}
	return o.XEnumNames
}

// GetXEnumNamesOk returns a tuple with the XEnumNames field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetXEnumNamesOk() ([]string, bool) {
	if o == nil || IsNil(o.XEnumNames) {
		return nil, false
	}
	return o.XEnumNames, true
}

// HasXEnumNames returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasXEnumNames() bool {
	if o != nil && !IsNil(o.XEnumNames) {
		return true
	}

	return false
}

// SetXEnumNames gets a reference to the given []string and assigns it to the XEnumNames field.
func (o *JsonSchemaProperty) SetXEnumNames(v []string) {
	o.XEnumNames = v
}

// GetEnum returns the Enum field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetEnum() []interface{} {
	if o == nil || IsNil(o.Enum) {
		var ret []interface{}
		return ret
	}
	return o.Enum
}

// GetEnumOk returns a tuple with the Enum field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetEnumOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Enum) {
		return nil, false
	}
	return o.Enum, true
}

// HasEnum returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasEnum() bool {
	if o != nil && !IsNil(o.Enum) {
		return true
	}

	return false
}

// SetEnum gets a reference to the given []interface{} and assigns it to the Enum field.
func (o *JsonSchemaProperty) SetEnum(v []interface{}) {
	o.Enum = v
}

// GetAllOf returns the AllOf field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetAllOf() []JsonSchema {
	if o == nil || IsNil(o.AllOf) {
		var ret []JsonSchema
		return ret
	}
	return o.AllOf
}

// GetAllOfOk returns a tuple with the AllOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetAllOfOk() ([]JsonSchema, bool) {
	if o == nil || IsNil(o.AllOf) {
		return nil, false
	}
	return o.AllOf, true
}

// HasAllOf returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasAllOf() bool {
	if o != nil && !IsNil(o.AllOf) {
		return true
	}

	return false
}

// SetAllOf gets a reference to the given []JsonSchema and assigns it to the AllOf field.
func (o *JsonSchemaProperty) SetAllOf(v []JsonSchema) {
	o.AllOf = v
}

// GetAnyOf returns the AnyOf field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetAnyOf() []JsonSchema {
	if o == nil || IsNil(o.AnyOf) {
		var ret []JsonSchema
		return ret
	}
	return o.AnyOf
}

// GetAnyOfOk returns a tuple with the AnyOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetAnyOfOk() ([]JsonSchema, bool) {
	if o == nil || IsNil(o.AnyOf) {
		return nil, false
	}
	return o.AnyOf, true
}

// HasAnyOf returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasAnyOf() bool {
	if o != nil && !IsNil(o.AnyOf) {
		return true
	}

	return false
}

// SetAnyOf gets a reference to the given []JsonSchema and assigns it to the AnyOf field.
func (o *JsonSchemaProperty) SetAnyOf(v []JsonSchema) {
	o.AnyOf = v
}

// GetOneOf returns the OneOf field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetOneOf() []JsonSchema {
	if o == nil || IsNil(o.OneOf) {
		var ret []JsonSchema
		return ret
	}
	return o.OneOf
}

// GetOneOfOk returns a tuple with the OneOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetOneOfOk() ([]JsonSchema, bool) {
	if o == nil || IsNil(o.OneOf) {
		return nil, false
	}
	return o.OneOf, true
}

// HasOneOf returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasOneOf() bool {
	if o != nil && !IsNil(o.OneOf) {
		return true
	}

	return false
}

// SetOneOf gets a reference to the given []JsonSchema and assigns it to the OneOf field.
func (o *JsonSchemaProperty) SetOneOf(v []JsonSchema) {
	o.OneOf = v
}

// GetRef returns the Ref field value if set, zero value otherwise.
func (o *JsonSchemaProperty) GetRef() string {
	if o == nil || IsNil(o.Ref) {
		var ret string
		return ret
	}
	return *o.Ref
}

// GetRefOk returns a tuple with the Ref field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchemaProperty) GetRefOk() (*string, bool) {
	if o == nil || IsNil(o.Ref) {
		return nil, false
	}
	return o.Ref, true
}

// HasRef returns a boolean if a field has been set.
func (o *JsonSchemaProperty) HasRef() bool {
	if o != nil && !IsNil(o.Ref) {
		return true
	}

	return false
}

// SetRef gets a reference to the given string and assigns it to the Ref field.
func (o *JsonSchemaProperty) SetRef(v string) {
	o.Ref = &v
}

func (o JsonSchemaProperty) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JsonSchemaProperty) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Schema.IsSet() {
		toSerialize["$schema"] = o.Schema.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if o.Title.IsSet() {
		toSerialize["title"] = o.Title.Get()
	}
	if o.Type != nil {
		toSerialize["type"] = o.Type
	}
	if o.Discriminator != nil {
		toSerialize["discriminator"] = o.Discriminator
	}
	if !IsNil(o.XReadOnly) {
		toSerialize["x-readOnly"] = o.XReadOnly
	}
	if !IsNil(o.XWriteOnly) {
		toSerialize["x-writeOnly"] = o.XWriteOnly
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if o.Format.IsSet() {
		toSerialize["format"] = o.Format.Get()
	}
	if o.Default != nil {
		toSerialize["default"] = o.Default
	}
	if o.MultipleOf.IsSet() {
		toSerialize["multipleOf"] = o.MultipleOf.Get()
	}
	if o.Maximum.IsSet() {
		toSerialize["maximum"] = o.Maximum.Get()
	}
	if o.Minimum.IsSet() {
		toSerialize["minimum"] = o.Minimum.Get()
	}
	if o.MaxLength.IsSet() {
		toSerialize["maxLength"] = o.MaxLength.Get()
	}
	if o.MinLength.IsSet() {
		toSerialize["minLength"] = o.MinLength.Get()
	}
	if o.Pattern.IsSet() {
		toSerialize["pattern"] = o.Pattern.Get()
	}
	if !IsNil(o.MaxItems) {
		toSerialize["maxItems"] = o.MaxItems
	}
	if !IsNil(o.MinItems) {
		toSerialize["minItems"] = o.MinItems
	}
	if !IsNil(o.UniqueItems) {
		toSerialize["uniqueItems"] = o.UniqueItems
	}
	if !IsNil(o.MaxProperties) {
		toSerialize["maxProperties"] = o.MaxProperties
	}
	if !IsNil(o.MinProperties) {
		toSerialize["minProperties"] = o.MinProperties
	}
	if !IsNil(o.XDeprecated) {
		toSerialize["x-deprecated"] = o.XDeprecated
	}
	if o.XDeprecatedMessage.IsSet() {
		toSerialize["x-deprecatedMessage"] = o.XDeprecatedMessage.Get()
	}
	if !IsNil(o.XAbstract) {
		toSerialize["x-abstract"] = o.XAbstract
	}
	if o.XNullable.IsSet() {
		toSerialize["x-nullable"] = o.XNullable.Get()
	}
	if o.XExample != nil {
		toSerialize["x-example"] = o.XExample
	}
	if !IsNil(o.XEnumFlags) {
		toSerialize["x-enumFlags"] = o.XEnumFlags
	}
	if !IsNil(o.XDictionaryKey) {
		toSerialize["x-dictionaryKey"] = o.XDictionaryKey
	}
	if !IsNil(o.Xml) {
		toSerialize["xml"] = o.Xml
	}
	if !IsNil(o.Not) {
		toSerialize["not"] = o.Not
	}
	if o.ExclusiveMaximum != nil {
		toSerialize["exclusiveMaximum"] = o.ExclusiveMaximum
	}
	if o.ExclusiveMinimum != nil {
		toSerialize["exclusiveMinimum"] = o.ExclusiveMinimum
	}
	if o.AdditionalItems != nil {
		toSerialize["additionalItems"] = o.AdditionalItems
	}
	if o.AdditionalPropertiesField != nil {
		toSerialize["additionalProperties"] = o.AdditionalPropertiesField
	}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if !IsNil(o.Required) {
		toSerialize["required"] = o.Required
	}
	if !IsNil(o.Properties) {
		toSerialize["properties"] = o.Properties
	}
	if !IsNil(o.PatternProperties) {
		toSerialize["patternProperties"] = o.PatternProperties
	}
	if !IsNil(o.Definitions) {
		toSerialize["definitions"] = o.Definitions
	}
	if !IsNil(o.XEnumNames) {
		toSerialize["x-enumNames"] = o.XEnumNames
	}
	if !IsNil(o.Enum) {
		toSerialize["enum"] = o.Enum
	}
	if !IsNil(o.AllOf) {
		toSerialize["allOf"] = o.AllOf
	}
	if !IsNil(o.AnyOf) {
		toSerialize["anyOf"] = o.AnyOf
	}
	if !IsNil(o.OneOf) {
		toSerialize["oneOf"] = o.OneOf
	}
	if !IsNil(o.Ref) {
		toSerialize["$ref"] = o.Ref
	}

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *JsonSchemaProperty) UnmarshalJSON(data []byte) (err error) {
	varJsonSchemaProperty := _JsonSchemaProperty{}

	err = json.Unmarshal(data, &varJsonSchemaProperty)

	if err != nil {
		return err
	}

	*o = JsonSchemaProperty(varJsonSchemaProperty)

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(data, &additionalProperties); err == nil {
		delete(additionalProperties, "$schema")
		delete(additionalProperties, "id")
		delete(additionalProperties, "title")
		delete(additionalProperties, "type")
		delete(additionalProperties, "discriminator")
		delete(additionalProperties, "x-readOnly")
		delete(additionalProperties, "x-writeOnly")
		delete(additionalProperties, "description")
		delete(additionalProperties, "format")
		delete(additionalProperties, "default")
		delete(additionalProperties, "multipleOf")
		delete(additionalProperties, "maximum")
		delete(additionalProperties, "minimum")
		delete(additionalProperties, "maxLength")
		delete(additionalProperties, "minLength")
		delete(additionalProperties, "pattern")
		delete(additionalProperties, "maxItems")
		delete(additionalProperties, "minItems")
		delete(additionalProperties, "uniqueItems")
		delete(additionalProperties, "maxProperties")
		delete(additionalProperties, "minProperties")
		delete(additionalProperties, "x-deprecated")
		delete(additionalProperties, "x-deprecatedMessage")
		delete(additionalProperties, "x-abstract")
		delete(additionalProperties, "x-nullable")
		delete(additionalProperties, "x-example")
		delete(additionalProperties, "x-enumFlags")
		delete(additionalProperties, "x-dictionaryKey")
		delete(additionalProperties, "xml")
		delete(additionalProperties, "not")
		delete(additionalProperties, "exclusiveMaximum")
		delete(additionalProperties, "exclusiveMinimum")
		delete(additionalProperties, "additionalItems")
		delete(additionalProperties, "additionalProperties")
		delete(additionalProperties, "items")
		delete(additionalProperties, "required")
		delete(additionalProperties, "properties")
		delete(additionalProperties, "patternProperties")
		delete(additionalProperties, "definitions")
		delete(additionalProperties, "x-enumNames")
		delete(additionalProperties, "enum")
		delete(additionalProperties, "allOf")
		delete(additionalProperties, "anyOf")
		delete(additionalProperties, "oneOf")
		delete(additionalProperties, "$ref")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableJsonSchemaProperty struct {
	value *JsonSchemaProperty
	isSet bool
}

func (v NullableJsonSchemaProperty) Get() *JsonSchemaProperty {
	return v.value
}

func (v *NullableJsonSchemaProperty) Set(val *JsonSchemaProperty) {
	v.value = val
	v.isSet = true
}

func (v NullableJsonSchemaProperty) IsSet() bool {
	return v.isSet
}

func (v *NullableJsonSchemaProperty) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJsonSchemaProperty(val *JsonSchemaProperty) *NullableJsonSchemaProperty {
	return &NullableJsonSchemaProperty{value: val, isSet: true}
}

func (v NullableJsonSchemaProperty) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJsonSchemaProperty) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
